include \masm32\include\masm32rt.inc

WindowCallback PROTO :HWND, :UINT, :WPARAM, :LPARAM

.code
start:
invoke GetModuleHandle, 0
invoke DialogBoxParam, eax, 1, 0, ADDR WindowCallback, 0
invoke ExitProcess, 0

WindowCallback proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    LOCAL hFile:HANDLE
    LOCAL hDC:HDC
    mov eax, uMsg

    .if     eax == WM_CLOSE         
         invoke EndDialog, hWnd, 0     
    .elseif eax == WM_PAINT         
         mov hDC, rv(GetDC, hWnd)
         xor    esi, esi     
         xor    edi, edi
         .while esi < 256        ;draw weird sin(x*y) == 0 looking thingie
             .while edi < 256
                 mov eax, edi
                 mul esi
                 invoke SetPixel, hDC, edi, esi, eax
                 inc    edi
              .endw
              xor edi, edi
              inc esi
         .endw         
         invoke ReleaseDC, hWnd, hDC    
    .else
        mov eax, 0 
    .endif
    ret
WindowCallback endp 
end start